<template>
    <Header />
    <div class="w-[1390px] m-0 m-auto">
        <div class="mt-5 mb-10">
            <p class="font-light cursor-pointer">
                <RouterLink to="/">Главная</RouterLink> > Люди и отношения
            </p>
        </div>

        <div class="my-10" v-if="subCatalogs.length > 0">
            <div class="flex items-center">
                <p class="py-1 px-7 rounded-full cursor-pointer"
                    :class="{ 'bg-[#7893AD] text-white': selectedSubCatalog === null }" @click="selectSubCatalog(null)">
                    Все
                </p>
                <div v-for="(subCatalog, index) in subCatalogs" :key="index" class="subCatalogItem">
                    <p class="rounded-full cursor-pointer py-1 px-7" @click="selectSubCatalog(subCatalog.subcatalogTitle)"
                        :class="{ 'bg-[#7893AD] text-white': selectedSubCatalog === subCatalog.subcatalogTitle }">
                        {{ subCatalog.subcatalogTitle }}
                    </p>
                </div>
            </div>
        </div>

        <div class="w-full grid grid-cols-4 gap-12 mb-20">
            <SetCard set-page="setPeopleAndRelationships" v-for="(set, index) in filteredPeopleAndRelationshipsSet" :key="index"
                :set="set" />
        </div>

        <div class="flex justify-center mb-14">
            <img src="../assets/add.svg" alt="">
        </div>

    </div>
    <Footer/>
</template>

<script>
import axios from 'axios';
import { RouterLink } from 'vue-router';
import Header from './Header.vue';
import SetCard from './SetCard.vue';
import Footer from "./Footer.vue"

export default {
    components: {
        Header, SetCard, Footer
    },
    data() {
        return {
            catalogs: [],
            subCatalogs: [],
            peopleAndRelationshipsSet: [],
            selectedSubCatalog: null
        }
    },
    mounted() {
        this.fetchData();
    },
    methods: {
        async fetchData() {
            try {
                const response = await axios.get("https://client.st.com.tm/api/catalogs")
                this.catalogs = response.data;

                const currentCatalog = this.catalogs.find(
                    catalog => catalog.catalogURL === "people-and-relationships"
                )

                if (currentCatalog && currentCatalog.subCatalogsName) {
                    this.subCatalogs = currentCatalog.subCatalogsName;
                }

                const responseSet = await axios.get("https://client.st.com.tm/api/sets")
                const sets = responseSet.data

                this.peopleAndRelationshipsSet = sets.filter(set => {
                    // Check if the set's catalogName includes "Сезоны"
                    return set.catalogName && set.catalogName.includes("Люди и отношения");
                });

            } catch (error) {
                console.log(error)
            }
        },
        selectSubCatalog(subCatalog) {
            this.selectedSubCatalog = subCatalog;
        }
    },
    computed: {
        filteredPeopleAndRelationshipsSet() {
            if (!this.selectedSubCatalog) {
                return this.peopleAndRelationshipsSet;
            } else {
                return this.peopleAndRelationshipsSet.filter(set => {
                    return set.subCatalogName && set.subCatalogName.some(subCatalog => subCatalog.subcatalogTitle === this.selectedSubCatalog);
                });
            }
        },
        selectedSubCatalogText() {
            if (!this.selectedSubCatalog) {
                return ""; // Return an empty string if no subCatalog is selected
            } else if (this.selectedSubCatalog === "Все") {
                return ""; // Return an empty string if "Все" subCatalog is selected
            } else {
                return `> ` + this.selectedSubCatalog; // Return the selected subCatalog
            }
        }
    }
}
</script>

<style scoped></style>

<style scoped></style>